<script setup>

import { ref, onMounted, inject } from 'vue'
import RoomTabs from '../components/RoomTabs.vue'
import VueTailwindDatepicker from "vue-tailwind-datepicker";
import { useRoute  } from 'vue-router'


const dialogOpen = defineModel()
const emit = defineEmits(['submit_success'])
const axios = inject('axios')
const dayjs = inject('dayjs')
const route = useRoute()
const dateValue = ref([])
const rooomValue = ref(0)
const AllLections = ref([])
const lection = ref(1)
const startHour = ref('8:00')
const endHour = ref('9:00')

const allowStartHours = ref(['08:00','09:00','10:00','11:00','12:00','13:00','14:00','15:00','16:00','17:00','18:00','19:00' ])
const allowEndHours = ref(['09:00','10:00','11:00','12:00','13:00','14:00','15:00','16:00','17:00','18:00','19:00','20:00' ])
const formatter = ref({
      date: 'YYYY-MM-DD',
      month: 'MMMM',
})


onMounted(() => {
      dateValue.value = dayjs().format('YYYY-MM-DD')
      
      axios.get(`lection_types/${localStorage.getItem("jwt")}`)
        .then(response => (AllLections.value = response.data))
      
    });

function onToggleDialog() {
      dialogOpen.value = !dialogOpen.value
    }


function createLection(){

  let startDate = dateValue.value + ' ' + startHour.value + ':00'
  let endDate = dateValue.value + ' ' + endHour.value + ':00'
  
  axios.post(`${localStorage.getItem("username")}/lections`,{
    params:{
      room_id :rooomValue.value,
      type:lection.value,
      start_time:startDate,
      end_time:endDate,
      jwt_token:localStorage.getItem('jwt')
    }
  }).then( function(response){
    if (response.status === 200){
      dialogOpen.value = false
      emit('submit_success')
    }
  })
}


</script>

<template>
<div class="relative z-10" aria-labelledby="modal-title" role="dialog" aria-modal="true">
  <div class="fixed inset-0 bg-gray-500 bg-opacity-75 transition-opacity"></div>
  <div class="fixed inset-0 z-10 w-screen overflow-y-auto">
    <div class="flex min-h-full items-end justify-center p-4 text-center sm:items-center sm:p-0">
     
      <div class="relative transform overflow-hidden rounded-lg bg-white text-left shadow-xl transition-all sm:my-8 ">
        <div class="bg-white px-4 pb-4 pt-5 sm:p-6 sm:pb-4">
          <form>
            <label for="countries" class="block my-4 text-sm font-medium text-gray-900 dark:text-white">Select Lection</label>
            <select v-model="lection" id="countries" class="bg-gray-50 border border-gray-300 text-gray-900 text-sm rounded-lg focus:ring-blue-500 focus:border-blue-500 block w-full p-2.5">
              <option  v-for="lection in AllLections" :value="lection.id">{{ lection.name }}</option>
            </select>
            <label  for="description" class="block my-4 text-sm font-medium text-gray-900 dark:text-white">Lection Description</label>
            <textarea v-if="AllLections.length" :value="AllLections[lection-1].description" readonly  id="description" rows="4" class="block p-2.5 w-full text-sm text-gray-900 bg-gray-50 rounded-lg border border-gray-300 focus:ring-blue-500 focus:border-blue-500" ></textarea>
          </form>
          <label for="message" class="block my-4 text-sm font-medium text-gray-900 dark:text-white">Select Room</label>
          <RoomTabs v-model="rooomValue"></RoomTabs>
          <label for="message" class="block my-4 text-sm font-medium text-gray-900 dark:text-white">Select Date and Time</label>
          <div class="grid gap-6 mb-6 md:grid-cols-2">
            <div>
              <vue-tailwind-datepicker :formatter="formatter" v-model="dateValue" no-input as-single/>
            </div>
            <div>
              <label for="message" class="block mb-4 text-sm font-medium text-gray-900 dark:text-white">Select Start Hour</label>
              <select v-model="startHour" id="startHours" class="bg-gray-50 border border-gray-300 text-gray-900 text-sm rounded-lg focus:ring-blue-500 focus:border-blue-500 block w-full p-2.5 ">
              <option  v-for="hour in allowStartHours" :value="hour">{{ hour }}</option>
             
            </select>
            <label for="message" class="block my-4 text-sm font-medium text-gray-900 dark:text-white">Select End Hour</label>
            <select v-model="endHour" id="endHours" class="bg-gray-50 border border-gray-300 text-gray-900 text-sm rounded-lg focus:ring-blue-500 focus:border-blue-500 block w-full p-2.5 ">
              <option  v-for="hour in allowEndHours" :value="hour">{{ hour }}</option>
            </select>
            </div>
          </div>
          
        </div>
        <div class="bg-gray-50 px-4 py-3 sm:flex sm:flex-row-reverse sm:px-6">
          <button @click="createLection()" type="button" class="inline-flex w-full justify-center rounded-md bg-emerald-600 px-3 py-2 text-sm font-semibold text-white shadow-sm hover:bg-emerald-500 sm:ml-3 sm:w-auto">Submit</button>
          <button @click="onToggleDialog()" type="button" class="mt-3 inline-flex w-full justify-center rounded-md bg-white px-3 py-2 text-sm font-semibold text-gray-900 shadow-sm ring-1 ring-inset ring-gray-300 hover:bg-gray-50 sm:mt-0 sm:w-auto">Cancel</button>
        </div>
        </div>
      </div>
    </div>
  </div>


</template>